function getFullFolderName(folder, include_server) {
	folderName = "";
	i = 0;
	while(!folder.isServer && i < 10) {
		folderName = folder.prettiestName + "/" + folderName;
		folder = folder.parent;
		i++;
	}
	if (include_server) {
		folderName = folder.prettiestName + "/" + folderName;
	}

	return folderName;
}

function getServerName(folder) {
	while(!folder.isServer && i < 10) {
		folderName = folder.prettiestName + "/" + folderName;
		folder = folder.parent;
		i++;
	}
	
	return folder.prettiestName;
}

function mailboxalert_replace(string, oldstr, newstr) {
	/* split-join method for replaceAll() */
	/* also escape spaces */
	var escaped_new = newstr.split(" ").join("\\ ");
	return string.split(oldstr).join(escaped_new);
}

function mailboxalert_lastUnread(mailbox) {
	var all = mailbox.getMessages(null);
	var unread = null;

	while (all.hasMoreElements()) {
		var cur = all.getNext().QueryInterface(Components.interfaces.nsIMsgDBHdr);
		if (!cur.isRead) {
			unread = cur;
		}
	}
	return unread;
}

function mailboxalert_alert(folder) {

/*
	if (folder.locked) {
	}
*/
	if (folder.flags & MSG_FOLDER_FLAG_VIRTUAL) {
/*		alert("virtual");*/
		return; // do nothing for saved searches
	}

//	if (folder.gettingNewMessages) {
		if (folder.flags) {
			mailboxalert_alert2(folder);
		} else {
/*			alert("update");*/
			folder.updateFolder(undefined);
		}
//	} else {
//		alert("!getting");
//	}
}

function mailboxalert_alert2(mailbox) {

	// Execute the system command from the prefs for the
	// mailbox

	try {

		var folder_name = getFullFolderName(mailbox, true);
		var server = getServerName(mailbox);
		var folder = getFullFolderName(mailbox, false);
		var new_message_count = mailbox.getNumUnread(false);
		var charset = mailbox.charset;

		last_unread = mailboxalert_lastUnread(mailbox);
		if (last_unread) {
			var messageKey = last_unread.messageKey;

			var subject = last_unread.subject;
			var sender = last_unread.author;
			//var body_text = last_unread.nogwa
			var body_text = "";

			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

			var command = "";

			try {
				command = prefs.getCharPref("extensions.mailboxalert.command."+folder_name);
			} catch (e) {
				// ok no command set for this mailbox
			}
			if (command) {
				/* Get the body of the message, thanks goes out to
				 * Mitch Graw, for his instructions on
				 * http://thunderbirddocs.blogspot.com/2005/02/thunderbird-extensions-how-to-get-body.html
				 */
				/*
				var offset = new Object();
				var messageSize = new Object();
				*/
				command = mailboxalert_replace(command, "%server", server);
				command = mailboxalert_replace(command, "%folder", folder);
				command = mailboxalert_replace(command, "%count", ""+new_message_count);
				command = mailboxalert_replace(command, "%subject", subject);
				command = mailboxalert_replace(command, "%sender", sender);
				command = mailboxalert_replace(command, "%charset", charset);


				/* replace some dangerous chars */
				/* 
				command = mailboxalert_replace(command, "<", "\\<");
				command = mailboxalert_replace(command, ">", "\\>");
				command = mailboxalert_replace(command, "&", "\\&");
				*/
				//alert(command);
				var args = new Array();
				var prev_i = 0;
				var i = 0;
				for (i; i < command.length; i++) {
					if (command.substr(i, 1) == " ") {
						if (i > 0 && command.substr(i-1, 1) != "\\") {
							//alert("adding " + command.substring(prev_i, i));
							var cur_arg = command.substring(prev_i, i);
							// remove escapes again
							cur_arg = cur_arg.split("\\ ").join(" ");
							args.push(cur_arg);
							prev_i = i;
						}
						else {
							//alert("space at pos "+i+" is escaped: "+command.substr(i-1, 1));
						}
					}
				}
				args.push(command.substr(prev_i, i).split("\\ ").join(" "));
				//alert(args.join("_._"));
				//                  var args = command.split(" ");
				var executable_name = args.shift();
				//alert(executable_name);
				var exec = Components.classes["@mozilla.org/file/local;1"].
				createInstance(Components.interfaces.nsILocalFile);
				var pr = Components.classes["@mozilla.org/process/util;1"].
				createInstance(Components.interfaces.nsIProcess);

				exec.initWithPath(executable_name);
				if (!exec.exists()) {
					alert(exec.leafName + " not found");
				} else {
					pr.init(exec);
					pr.run(false, args, args.length);

				}
			}
		}


	} catch (e) {
		dump("[mailboxalert] Exception: "+e);
	}
}

